#region License
// Copyright (c) 2007 James Newton-King
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
#endregion

using System.ComponentModel;

namespace Utilities.Test.Testing
{
  public class DummyGeneric<T, U, V, W> : INotifyPropertyChanged
  {
    private T _myT;

    public T MyT
    {
      get { return _myT; }
      set
      {
        _myT = value;
        FirePropertyChanged("MyT");
      }
    }

    private U _myU;

    public U MyU
    {
      get { return _myU; }
      set
      {
        _myU = value;
        FirePropertyChanged("MyU");
      }
    }

    private V _myV;

    public V MyV
    {
      get { return _myV; }
      set
      {
        _myV = value;
        FirePropertyChanged("MyV");
      }
    }

    private W _myW;

    public W MyW
    {
      get { return _myW; }
      set
      {
        _myW = value;
        FirePropertyChanged("MyW");
      }
    }

    public event PropertyChangedEventHandler PropertyChanged;

    public void FirePropertyChanged(string propertyName)
    {
      if (PropertyChanged != null)
        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
    }
  }
}